;-- http://radiohlam.ru -  ,   
;------------------------------------------------------------------
 list    p = 12f629
 __config 01FE4h          ;  01111 11 1 1 0 0 100 - (7,8)  , (6)   ,
                          ;  (5)GP3/-MCLR   -MCLR, (4)PWRT , (3)  - , (2-0) - 
;*********  ************************************
         CBLOCK 0x20      ;    
         MBC              ;    ( - 889uS)
         LBC              ;   
         Schetchik        ;   
         Flags_reg        ;  : 0-  -    (0 - , 1 -  )
         Current_time     ; ,  
         Half_time        ;   3/4 
         Counter          ;   
         ENDC             ;
;********  ***************************************
Sys        equ         .29         ;  
CMD_1      equ         .8          ;    000010 00  2   

INDF       equ         0h          ;   
Status     equ         03h         ;   .
FSR        equ         04h         ;     
GPIO       equ         05h         ;    .
Cmcon      equ         19h         ;  Cmcon - 
TrisIO     equ         05h         ;      .
INTCON     equ         0Bh         ;  (1)/(0) 
IOCB       equ         16h         ;     GP0...GP5
OSCCAL     equ         10h         ;    
OPT_REG    equ         01h         ;   ( 1)
TMR0       equ         01h         ;   ( 0)
F          equ         1           ;    .
;********************************************************
;    GP0 (1- ), GP1(2- ), GP2(), GP4() -     , GP5 -  -
;********************************************************
          org 0
          goto start
          org 4
;*********  *************************************************************************
           movf  Schetchik,0          ;    
           btfss Status,2             ;    -    (   )
           goto  Priem
;******  ,      **********************************************
Nachalo    clrf  TMR0                 ;  
           bcf   INTCON,2             ;    
           bsf   INTCON,5             ;    
           bsf   Status,0             ;   
           rlf   LBC,1                ; (    1)
           rlf   MBC,1
           incf  Schetchik,1
           goto  exit
;******  ,       **************************
Priem      btfsc INTCON,2             ;      -  
           goto  Reset
;******  ,     ************************************************
           movf  TMR0,0               ;   
           movwf Current_time         ;  
           clrf  TMR0                 ;  
           decfsz Schetchik,0         ;    1,   
           goto  Next
;-----      -----
First      movf  Current_time,0
           movwf Half_time            ;   
           bcf   Status,0
           rrf   Half_time,0          ;    
           addwf Half_time,1          ;   3/4  (   3/4  <0,     1/2,    1)
;-----     1,    ,     
           bsf   Flags_reg,0
           bsf   Status,0
           rlf   LBC,1
           rlf   MBC,1
           incf  Schetchik,1
           goto  exit
;-----   ------------------
Next       btfss Flags_reg,0          ;      -  
           goto  Signed_front
;-----    ---------------
Not_signed_front
           bcf   Flags_reg,0          ;    
           goto  exit
;-----     ------------
Signed_front
           movf  Half_time,0          ;  -    
           subwf Current_time,0
           btfss Status,0             ;     - ,   -  
           goto  Long_time
;-----    ------------
Short_time bsf   Flags_reg,0          ;   ,     
           bcf   Status,0             ;          
           btfsc LBC,0                ;    0,   
           bsf   Status,0
           goto  Zapis_bita           ;          
;-----    -------------
Long_time  bcf   Status,0             ;   ,     
           btfss LBC,0                ;    1,   
           bsf   Status,0
;-----     ---
Zapis_bita rlf   LBC,1
           rlf   MBC,1
           incf  Schetchik,1
           movlw .14                  ;  -    14 
           subwf Schetchik,0          ;   = 14,    Z
           btfsc Status,2             ;  ,     Z
           goto  Rabota
           goto  exit
;*********         *******************************
exit       bcf     INTCON,0
           retfie

;********   ********************************************************
;***  ,      , **********
;***    , OSCCAL    03FFh,     BOR - *
;*** 12-,13-    (   BOR - 01, OSCCAL - 346C)*****************
;******   *****************************************************************
start       bsf         Status,5         ;
            Call        3FFh             ;     w
            movwf       OSCCAL           ;
;********    GP5 -  ,  GP4-GP0 -   ********************
            bcf         Status,5         ;    0
            clrf        GPIO             ;   (   ,  GP5)
            movlw       .7               ;  0..2 
            movwf       Cmcon            ;  , GP0, GP1, GP2 -  /
            bsf         Status,5         ;   1-  (  1 5-   Status).
            movlw       .40              ;   GPIO   (W)    .40=00 101000 GP0, GP1, GP2, GP4 - ,  - 
            movwf       TrisIO           ;   GPIO  W   TrisIO
;******         ***********************************
Reset       bcf         Status,5
            movf        GPIO,0           ;      
            clrf        INTCON           ;       
            clrf        LBC              ;  LBC
            clrf        MBC              ;  MBC
            clrf        Schetchik        ;    
            clrf        Flags_reg        ;   
;******     GP5 *****************************************************
            bsf         Status,5
            movlw       .32              ; .32 = 00100000
            movwf       IOCB             ;     GP5,   - 
            bcf         Status,5         ;   0-  (  0 5-   Status).
            bsf         INTCON,3         ;    GPIO
;******   *****************************************************
            bsf         Status,5         ;   1- 
            movlw       b'00000110'      ;   1:128, 128*256=32,768 
            movwf       OPT_REG
            bcf         Status,5         ;   0- 
;******   *************************************************
            bsf         INTCON,7         ;  
;******      ****************************************
Scan       goto Scan


;*******   *******************************************************
Rabota   clrf INTCON    ;       
         bcf  Status,0
         rlf  LBC,1     ;  2 ,    
         rlf  MBC,1     ;  ,   
         rlf  LBC,1
         rlf  MBC,1
         bcf  Status,0  ;      ,
         rrf  LBC,1     ;        
         bcf  Status,0
         rrf  LBC,1
;----------------------------------------------------------------------------
         movlw .1
         subwf LBC,0
         btfsc Status,2 ;    1 -  
         goto  Button1
         movlw .2
         subwf LBC,0
         btfsc Status,2 ;    2 -  
         goto  Button2
         movlw .3
         subwf LBC,0
         btfsc Status,2 ;    3 -  
         goto  Button3
         movlw .4
         subwf LBC,0
         btfsc Status,2 ;    4 -  
         goto  Button4
         goto  Thats_All
;-----    --------------------
Button1  movlw b'00000001'
         xorwf GPIO,1
         goto  Thats_All
;-----    --------------------
Button2  movlw b'00000010'
         xorwf GPIO,1
         goto  Thats_All
;-----    --------------------
Button3  movlw b'00000100'
         xorwf GPIO,1
         goto  Thats_All
;-----    --------------------
Button4  movlw b'00010000'
         xorwf GPIO,1
;------    -----------
Thats_All call  Pause
          goto  Reset

;*******  ****************************************************************************
          movlw  .255
          movwf  Counter
Pause     nop
          decfsz Counter,1
          goto Pause
          return        
 end
